def gv
pipeline {
	agent any
	parameters {
		choice(name: 'VERSION', choices: ['1', '2', '3'], description: 'version to be deploy on prod') 
		booleanParam(name: 'executeTests', defaultValue: true, description: 'some description') 
 	}
	stages {
		stage("init") {
			
			steps {
				script {
					gv = load "script.groovy"
				}
			}
		}
		stage("build") {
			
			steps {
			    script {
					gv.buildApp()
				}
			}
		}
        stage("test") {
			when {
				expression {
					params.executeTests
				}
			}
			steps {
                script {
					gv.testApp()
				}
			}
		}
        stage("deploy") {
			steps {
                script {
					env.ENV = input message: "Select the enironment to deloy to", ok: "Done", parameters: [choice(name: 'ONE', choices: ['dev', 'staging', 'prod'], description: 'version to be deploy on prod')]
					gv.deployApp()
					echo  "Deploying to ${ENV}"

				}
			}
		}
	}
}
